
disp('****************************************')
disp('Euro Area -- Busines Cycle Analysis')
disp('****************************************')

%%
d = databank.fromCSV('EA_data.csv'); 

%% Seasonal adjustment
d = dbbatch(d,'$1','x12(d.$0, Inf, ''mode'', ''m'' )', 'namefilter', '(.*)_U', 'fresh', false);

%% remove unadjusted series
d = d - {'GDP_U', 'CPI_U', 'CPI_CORE_U'};

%% Make log of variables
exceptions = {'EURIBOR1M', 'EURIBOR3M', 'RS_MP_TARGET'};

d = dbbatch(d,'L_$0','100*log(d.$0)','namelist',fieldnames(d)-exceptions, 'fresh', false);

%% Growth rate qoq, yoy
d = dbbatch(d, 'DLA_$1', '4*diff(d.$0)', 'namefilter', 'L_(.*)', 'fresh',false);
d = dbbatch(d, 'D4L_$1', 'diff(d.$0,-4)', 'namefilter', 'L_(.*)', 'fresh',false);

%% Gap
[d.L_GDP_BAR, d.L_GDP_GAP] = hpf(d.L_GDP);

%% observed variables
dobs.OBS_RS        = d.RS_MP_TARGET;%d.EURIBOR3M;
dobs.OBS_L_CPI     = d.L_CPI_CORE;
[d.RR_BAR, d.RR_GAP] = hpf(dobs.OBS_RS - (dobs.OBS_L_CPI - dobs.OBS_L_CPI{-4}));
d.RR = dobs.OBS_RS - (dobs.OBS_L_CPI - dobs.OBS_L_CPI{-4});

dobs.OBS_L_GDP_GAP = d.L_GDP_GAP;
dobs.OBS_L_GDP     = d.L_GDP;
dobs.OBS_L_S       = d.L_S;
dobs.OBS_RR_BAR    = d.RR_BAR;
dobs.OBS_RR        = d.RR;

%% save results

save('EA_BC.mat', 'd', 'dobs');
clear d dobs