close all
clear all

%% step 1
m = readmodel_step_1;

plist = ["a1", "a2", "b1", "b2", "g", "std_shk_dla_cpi", "sc"];

% Set to a larger number in practice.
numDraws = 100;

fprintf("Resample %g times from calibrated model.\n", numDraws);

% Simulate a total of numDraws artificial data, length 40 periods.
d = resample(m, [ ], 1:40, numDraws, "deviation", false);

disp("Compute Hessians for each draw and average them")

[mloglik, s, F1] = diffloglik( ...
    m, d, 1:40, plist ...
    , "deviation", true ...
    , "relative", false ...
    , "progress", true ...
);

F1 = mean(F1, 3);

[u1, s1] = svd(F1);

u1 = NamedMatrix(u1, plist, []);

s1 = diag(s1);
s1 = s1 / s1(1);

format shortEng
disp("Singular values (normalised and ordered)")
disp("Time domain")
disp(s1.');

disp('Model #1')
u1

%% step 2
m = readmodel_step_2;

plist = ["a1", "a2", "ar", "a0", "ag", "b1", "b2", "std_shk_dla_cpi", "std_shk_y_gap", "std_shk_y_bar"];

% Set to a larger number in practice.
numDraws = 100;

fprintf("Resample %g times from calibrated model.\n", numDraws);

% Simulate a total of numDraws artificial data, length 40 periods.
d = resample(m, [ ], 1:40, numDraws, "deviation", false);

disp("Compute Hessians for each draw and average them")

[mloglik, s, F1] = diffloglik( ...
    m, d, 1:40, plist ...
    , "deviation", true ...
    , "relative", false ...
    , "progress", true ...
);

F1 = mean(F1, 3);

[u1, s1] = svd(F1);

u1 = NamedMatrix(u1, plist, []);

s1 = diag(s1);
s1 = s1 / s1(1);

format shortEng
disp("Singular values (normalised and ordered)")
disp("Time domain")
disp(s1.');

disp('Model #2')
u1

%% step 3
m = readmodel_step_3;

plist = ["a1", "a2", "ar", "b1", "b2", "std_shk_dla_cpi", "std_shk_y_gap", "std_shk_y_bar"];

% Set to a larger number in practice.
numDraws = 100;

fprintf("Resample %g times from calibrated model.\n", numDraws);

% Simulate a total of numDraws artificial data, length 40 periods.
d = resample(m, [ ], 1:40, numDraws, "deviation", false);

disp("Compute Hessians for each draw and average them")

[mloglik, s, F1] = diffloglik( ...
    m, d, 1:40, plist ...
    , "deviation", true ...
    , "relative", false ...
    , "progress", true ...
);

F1 = mean(F1, 3);

[u1, s1] = svd(F1);

u1 = NamedMatrix(u1, plist, []);

s1 = diag(s1);
s1 = s1 / s1(1);

format shortEng
disp("Singular values (normalised and ordered)")
disp("Time domain")
disp(s1.');

disp('Model #3')
u1
