close all
clear all

addpath ../General_codes/
rng_ = qq(2002,1):qq(2019,4);
% rng_ = qq(2002,1):qq(2022,2);
%%
load('../../UK/UK_BC.mat', 'dobs');
% tmp = readtable("inputData\rstar.data.us.csv");
% 
d.gdp = dobs.OBS_L_GDP;
d.inflation = 4*(dobs.OBS_L_CPI-dobs.OBS_L_CPI{-1});
d.inflation_expectations = (d.inflation + d.inflation{-1} + d.inflation{-2} + d.inflation{-3})/4;
d.interest = dobs.OBS_RS;
% 
d.real_i = d.interest - d.inflation_expectations;%% expectations originally inflation


%% step 1
m = readmodel_step_1;


dd.obs_dla_cpi = d.inflation;
dd.obs_y = d.gdp;

E = struct();

E.a1 = {NaN, 0.01, 2};
E.a2 = {NaN, -1, 2};

 
E.b1 = {NaN, 0.1, 0.95};
E.b2 = {NaN, 0.025, 0.95};

E.g   = {NaN, 0.1, 10};

E.std_shk_dla_cpi = {NaN, 0.1, 15};
% E.std_shk_y_gap = {0.5, 0.1, 15};
% E.std_shk_y_bar = {0.5, 0.1, 15};
E.sc = {NaN, 0.1, 15};

% 
[summary_1, pos, C, H, mest]  = estimate(m,dd, rng_, E, 'noSolution', 'penalty', 'tolx', 1e-12, 'filter', {'relative', false});

disp('Value of the likelihood function at the optimum')

disp('Maximum likelihood estimates');
summary_1

[m_kf,g,v,delta,pe] = filter(mest,dd,rng_, 'relative', false);

bestim = median_unbiased_estimator(g.mean.y_bar);
% plot([g.mean.y_gap Series(qq(1961,1), reshape(tmp', [39*6,1]))])
if bestim == 0
    bestim = 0.05;
    disp('BESTIM HACK')
end
%% step 2

m2 = readmodel_step_2;
m2.lambda = bestim;
m2 = solve(m2);

dd.obs_dla_cpi = d.inflation;
dd.obs_y = d.gdp;
dd.obs_r = d.real_i;

E = struct();

E.a1 = {NaN, 0.01, 2};
E.a2 = {NaN, -1, 2};
E.ar = {NaN, -1, -0.0025};
E.a0 = {NaN, -5, 5};
E.ag = {NaN, -5, 5};

E.b1 = {NaN, 0.1, 0.95};
E.b2 = {NaN, 0.025, 0.95};

E.std_shk_dla_cpi = {NaN, 0.1, 15};
E.std_shk_y_gap = {0.5, 0.1, 15};
E.std_shk_y_bar = {0.5, 0.1, 15};
% E.sc = {NaN, 0.1, 15};

% 
[summary_2, pos, C, H, mest]  = estimate(m2, dd, rng_, E, 'noSolution', 'penalty', 'tolx', 1e-12, 'filter', {'relative', false});

disp('Value of the likelihood function at the optimum')

disp('Maximum likelihood estimates');
summary_2

[m_kf,g2,v,delta,pe] = filter(mest, dd, rng_, 'relative', false);


% rng_ = qq(1961,1):qq(2019,2);
xx =  [g2.mean.y_gap{-1} g2.mean.y_gap{-2} (g2.mean.r{-1}+g2.mean.r{-2})/2 g2.mean.g ...
       Series(rng_, 1)];
bestim_2 = median_unbiased_estimator2(g2.mean.y_gap{rng_}, xx{rng_});

%% step 3
if bestim_2 == 0
    bestim_2 = 0.05;
end

m3 = readmodel_step_3;
m3.lambda_adj = sqrt(1+bestim^2);
m3.lambda_z = bestim_2/4;
disp('Z hack')
m3.lambda = bestim;
m3 = solve(m3);

dd.obs_dla_cpi = d.inflation;
dd.obs_y = d.gdp;
dd.obs_r = d.real_i;
dd.obs_z = Series(rng_(1), 0);

E = struct();

E.a1 = {NaN, 0.01, 2};
E.a2 = {NaN, -1, 2};
E.ar = {NaN, -1, -0.0025};

E.b1 = {NaN, 0.1, 0.95};
E.b2 = {NaN, 0.025, 0.95};

E.std_shk_dla_cpi = {NaN, 0.1, 15};
E.std_shk_y_gap = {0.5, 0.1, 15};
E.std_shk_y_bar = {0.5, 0.1, 15};
% E.sc = {NaN, 0.1, 15};

% 
[summary_3, pos, C, H, mest]  = estimate(m3, dd, rng_, E, 'noSolution', 'penalty', 'tolx', 1e-12, 'filter', {'relative', false});

disp('Value of the likelihood function at the optimum')

disp('Maximum likelihood estimates');
summary_3

[m_kf,g3,v,delta,pe] = filter(mest, dd, rng_, 'relative', false);

out.r_bar = 4*g3.mean.g + g3.mean.z;
out.r = g3.mean.r;

figure
subplot(311)
plot([g.mean.y_gap g2.mean.y_gap g3.mean.y_gap])
legend('Est 1', 'Est 2', 'Est 3', 'Box', 'off')
title('Output gap')
zeroline;
subplot(312)
plot([g2.mean.g g3.mean.g])
title('Potential growth')
subplot(313)
plot([g3.mean.z])
title('Potential growth Z')

figure
plot([out.r out.r_bar])

figure
plot([out.r out.r_bar 4*g3.mean.g])
legend('r', 'bar', 'g', 'Box', 'off')
title('Real rate and bar')

figure
bar([g3.mean.a1*g3.mean.y_gap{-1}+g3.mean.a2*g3.mean.y_gap{-2}, ...
    g3.mean.ar/2*(g3.mean.r{-1}-4*g3.mean.g{-1}-g3.mean.z{-1} + g3.mean.r{-2}-4*g3.mean.g{-2}-g3.mean.z{-2}), g3.mean.shk_y_gap], 'stacked')
title('Decomposition of output gap')
legend('Lag', 'R', 'Shock', 'Box', 'off')

databank.toCSV(out, 'rstar.csv')