
disp('****************************************')
disp('Morocco -- Busines Cycle Analysis')
disp('****************************************')

%%
d = dbload('MA_data.csv'); 

%% extrapolate data
d.CPI_U = d.CPI;
for i = get(d.CPI_NEW, 'first')+4:get(d.CPI_NEW, 'last')
    d.CPI_U(i) = d.CPI_NEW(i)/d.CPI_NEW(i-4)*d.CPI_U(i-4);
end


for i = get(d.GDP_NEW, 'first')+4:get(d.GDP_NEW, 'last')
    d.GDP_U(i) = d.GDP_NEW(i)/d.GDP_NEW(i-4)*d.GDP_U(i-4);
end

%% Seasonal adjustment
d = dbbatch(d,'$1','x12(d.$0, Inf, ''mode'', ''m'' )', 'namefilter', '(.*)_U', 'fresh', false);

%% remove unadjusted series
d = d - {'GDP_U', 'CPI_U', 'CPI_CORE_U', 'CPI_NEW'};

%% Make log of variables
exceptions = {'BELIBOR1M', 'BELIBOR3M', 'RS_MP_TARGET'};

d = dbbatch(d,'L_$0','100*log(d.$0)','namelist',fieldnames(d)-exceptions, 'fresh', false);

%% Growth rate qoq, yoy
d = dbbatch(d, 'DLA_$1', '4*diff(d.$0)', 'namefilter', 'L_(.*)', 'fresh',false);
d = dbbatch(d, 'D4L_$1', 'diff(d.$0,-4)', 'namefilter', 'L_(.*)', 'fresh',false);

warning('MA: GDP pre-filtering!!!')
d.L_GDP = hpf(d.L_GDP, Inf, 'lambda', 0.1);

%% observed variables
dobs.OBS_RS    = d.RS_MP_TARGET;%d.BELIBOR3M;
dobs.OBS_L_GDP = d.L_GDP;
dobs.OBS_L_S   = d.L_S;
dobs.OBS_L_CPI = d.L_CPI;


%% save results

save('MA_BC.mat', 'd', 'dobs');
% clear d dobs